#pragma once

#include "CGlobals.h"

const int C_SOUND_SPLAT = 0;
const int C_SOUND_TOILET = 1;
const int C_SOUND_POINT = 2;
const int C_SOUND_MISTAKE = 3;
const int C_SOUND_PICKUP = 4;

const int C_SOUND_COUNT = 5;



class CSoundPlayer
{
public:

    void InitSounds()
    {
        m_a_sound[C_SOUND_SPLAT].Load(glo.m_p_sound, "splat.wav");
        m_a_sound[C_SOUND_TOILET].Load(glo.m_p_sound, "toilet.wav");
        m_a_sound[C_SOUND_POINT].Load(glo.m_p_sound, "point.wav");
        m_a_sound[C_SOUND_MISTAKE].Load(glo.m_p_sound, "sheep_laugh.wav");
        m_a_sound[C_SOUND_PICKUP].Load(glo.m_p_sound, "pickup.wav");
             
    }

    void Play(int i_sound)
    {
        assert(i_sound < C_SOUND_COUNT);
        m_a_sound[i_sound].Play();
    }

private:
    CDXSoundBuffer m_a_sound[C_SOUND_COUNT];
};

extern CSoundPlayer g_sound_player;