#include "CThingAnim.h"
#include "CGlobals.h"

CThingAnim::CThingAnim()
{
  SetAnimType(0);
  SetAnimDelay(333); //3 frames a second
  SetMaxFrameOfAnim(0); //disabled
}

bool CThingAnim::SetAnim(char *p_fname, int i_width, int i_height, int i_count)
{

  	if (!m_sprite.Create(glo.m_Screen,p_fname,i_width,i_height,i_count))
    {
        CDXLOG("Error loading %s.", p_fname);
        return false;
    }
	m_sprite.SetFrame(1);
	m_sprite.SetColorKey(RGB(255,255,255));
  
    return true; //success
}


void CThingAnim::Draw()
{
    //CThingSprite::Draw(); //draw this stuff too, if applica
    m_sprite.SetPos(m_f_x, m_f_y);
   	
    if (m_b_h_flip)
    {
    m_sprite.Draw(glo.m_Screen->GetBack(),0, 0, CDXBLT_TRANSHFLIP);

    }   else
    {
    
    m_sprite.Draw(glo.m_Screen->GetBack(),0, 0, CDXBLT_TRANS);
    }
}

void CThingAnim::Think()
{
    CThingSprite::Think(); //do this stuff too
    if (m_i_animation_type == C_THING_ANIM_NORMAL)
    {
        if (m_timer_anim.interval_reached())
        {
            //advance the animation by one
            int i_frame = m_sprite.GetFrame()+1;
            if (m_i_max_frame != 0)
            {
                if (i_frame > m_i_max_frame) i_frame = 1;
                
            }   else
            {
                
                if (i_frame > m_sprite.CountFrames()) i_frame = 1;
            }
            m_sprite.SetFrame(i_frame);
        }
    }

    if (m_b_allow_auto_depth_sort)
    {
        
        //let's depth sort it
        if (m_sprite.GetTile()->GetBlockWidth() != 0)
        {
            SetSort(m_f_y + m_sprite.GetTile()->GetBlockHeight());
        }
    }

}





