#include "CThingSprite.h"
#include "CGlobals.h"

  

CThingSprite::CThingSprite()
{
    m_f_x = 0;
    m_f_y = 0;
    m_f_angle = 0;
    m_f_scale = 1;
    m_st_text[0] = 0;
    SetSpecial(C_THING_SPRITE_NONE);
    m_b_die_timer_active = false;
    m_f_dir = 0;
    m_f_vel = 0;
    SetAllowAutoDepthSort(true);
    SetHFlip(false);

}

void CThingSprite::SetAllowAutoDepthSort(bool b_new)
{
   m_b_allow_auto_depth_sort = b_new;
}

void CThingSprite::SetSpecial(int i_new)
{
  
    m_i_special = i_new;
    
    if (m_i_special == C_THING_SPRITE_BOUNCE_AND_DIE)
    {
        //special setup
        SetKillTimer(2000);
        m_f_special_move = 0;
     //   m_f_scale = 0.1f;
    }
}
void CThingSprite::SetKillTimer(int i_ms)
{
    m_timer_die.set_interval(i_ms);
    m_b_die_timer_active = true;
}

void CThingSprite::SetText(char *p_new)
{
    strcpy(m_st_text, p_new);
}

void CThingSprite::SetPosition(float f_new_x, float f_new_y)
{
    m_f_x = f_new_x;
    m_f_y = f_new_y;
}
  
bool CThingSprite::SetImage(char *p_st_name, bool b_white_is_transparent)
{
    
    if (!m_sprite.Create(glo.m_Screen, p_st_name))
   {
       CDXLOG("Error loading bitmap (%d)", 4);
       return false;
   }
   m_b_white_is_transparent = b_white_is_transparent;
   if (m_b_white_is_transparent)
   {
      m_sprite.SetColorKey(RGB(255,255,255)) ;
   }
 
  return true; //success
}

void CThingSprite::Think()
{
    if (m_i_special == C_THING_SPRITE_BOUNCE_AND_DIE)
    {
      m_f_special_move += 200*glo.m_f_delta;
      
      m_f_x += sin(m_f_special_move)*0.45;
      m_f_y += cos(m_f_special_move)*0.45;
    }
   

    if (m_f_vel != 0)
    {
        m_f_x += sin(m_f_dir)*m_f_vel*glo.m_f_delta;
        m_f_y += cos(m_f_dir)*m_f_vel*glo.m_f_delta;
    }


    if (m_b_die_timer_active)
    {
        if (m_timer_die.interval_reached())
        {
            SetDeleteRequest(true);
        }
    }
}


void CThingSprite::Draw()
{
    if (m_st_text[0] != 0)
    {
        //show a text message instead of a graphic
         glo.m_Screen->GetBack()->GetDC(); 
        glo.m_Screen->GetBack()->SetFont(); 
        glo.m_Screen->GetBack()->TextXY(5, 5, 255, m_st_text); // TextXY(x, y, color, string)
        glo.m_Screen->GetBack()->ReleaseDC();
    
        return;
    }
 
    if (m_sprite.GetWidth() != 0)
  {
        if (m_f_scale != 1.0f)
        {
           
            //unbelievable slow.
            if (!m_sprite.DrawTransRotoZoom(glo.m_Screen->GetBack(), long(m_f_x), long(m_f_y),
                m_sprite.GetClipRect(), m_f_angle, m_f_scale))
            {
                CDXLOG("Error drawing") ;
            }
            
            
        }  else
        {
            if (!m_b_white_is_transparent)
            {
                m_sprite.DrawBlk(glo.m_Screen->GetBack(), long(m_f_x), long(m_f_y));
                
            }   else
            {
                
                m_sprite.DrawTrans(glo.m_Screen->GetBack(), long(m_f_x), long(m_f_y));
            }
        }
        
    }
  
    
}
